<template>
  <div
    style="
      overflow-y: scroll;
      overflow-x: hidden;
      background-color: white;

      position: fixed; 
      z-index: 2; 
      top: 0; 
      bottom: 0; 
      left: 0; 
      right: 0;
      box-sizing: border-box;
    "
  >
    <div class="header">

      <router-link :to="{ name: 'main' }">
        <div
          :style="`background-image: url(${require('@/assets/img/arrow-back.svg')})`"
          style="
            position: absolute;
            left: 12px;
            top: 45px;
            overflow: hidden;
            cursor: pointer;
            text-align: center;
            box-sizing: border-box;
            padding: 20px;
            background-repeat: no-repeat;
            background-position: center;
          "
        ></div>
      </router-link>
      
      Список товаров
    </div>


    <div
      v-for="good in $store.state.inventories"
      :key="good.product_id"
      style="margin: 1px 0; background: rgb(255, 0, 26); background: linear-gradient(90deg,rgba(255, 0, 26, 1) 0%, rgba(42, 24, 181, 1) 100%);">
      <div
        @touchstart="handleTouchStart($event)"
        @touchmove="handleTouchMove($event, good)"
        @touchend="touchStart = 0; touchDistance = 0; $event.target.style.left = '-5px'; isScrolling = null"
        style="
          position: relative;
          overflow: hidden;
          background-color: #ffffff;
          padding: 30px 80px 30px 50px;
          text-align: left;
          text-overflow: ellipsis;
          white-space: nowrap;
          overflow: hidden;
          left: -5px;
        "
      >
        <span
          style="pointer-events: none; "

          >{{ good.product.name }}</span
        >
        <br />
        <span
          style="pointer-events: none"

          >{{ good.price_actual }}₸</span
        >
        <div
          style="
            pointer-events: none;
            position: absolute;
            left: 20px;
            top: calc(50% - 8px);
          "
        >
          {{ showQuantity(good.product_id) }}
        </div>
        <!-- <div
          :style="`background-image: url( ${require(`@/assets/img/${good.img_url}`)} )`"
          style="
            pointer-events: none;
            position: absolute;
            width: 35px;
            height: 35px;
            right: 35px;
            top: calc(50% - 16px);
            background-size: contain;
          "
        ></div> -->
      </div>
    </div>

  </div>
</template>

<script>
export default {

  data() {
    return {
      xDown: null,
      yDown: null,
      touchStart: 0,
      touchDistance: 0,
      swiped: false,
      isScrolling: null,
      start: {
        x: null,
        y: null,
      },
      delta: {
        x: null,
        y: null
      }
    }
  },

  created() {
    // if (!this.$store.state.shops.length) {
    //   this.$store.dispatch('getShopInventories');
    // }
  },

  methods: {

    showQuantity(productId) {
      let findProduct = this.$store.state.basket.find((el) => el.product_id === productId);

      if (findProduct) {
        if (findProduct.amount > 0) {
          return findProduct.amount + 'x';
        }
      }
    },

    handleTouchStart(event) {

      event.stopPropagation();
      this.touchStart = event.touches[0].clientX;

      this.start.x = event.touches[0].pageX;
      this.start.y = event.touches[0].pageY;
    },

    handleTouchMove(event, good) {

      this.delta.x = event.touches[0].pageX - this.start.x;
      this.delta.y = event.touches[0].pageY - this.start.y;

      if (this.isScrolling == null) {
        this.isScrolling = !!( this.isScrolling || Math.abs(this.delta.x) < Math.abs(this.delta.y) );
      }

      console.log(this.delta.x, this.delta.y);
      this.touchDistance = event.touches[0].clientX - this.touchStart;

      if (!this.isScrolling) {
        

      // if (this.touchDistance > 5) {
        event.preventDefault();
      // }

      // if (this.touchDistance > 10 || this.touchDistance < 10) {
        
        event.target.style.left = this.touchDistance + 'px';

      // }

      if (parseInt(event.target.style.left, 10) < -85) {
        event.target.style.left = '-85px';
      }

      if (parseInt(event.target.style.left, 10) > 85) {
        event.target.style.left = '85px';
      }

      if (parseInt(event.target.style.left, 10) < -80 && this.swiped === false) {
        this.$store.commit('ADD_PRODUCT_IN_BASKET', { product: { ...good.product, price_actual: good.price_actual } });
      } else if (parseInt(event.target.style.left, 10) > 80 && this.swiped === false) {
        this.$store.commit('REMOVE_PRODUCT_FROM_BASKET', { productId: good.product_id });
      }
      
      if (parseInt(event.target.style.left, 10) < -80 || 
            parseInt(event.target.style.left, 10) > 80 && 
              (this.swiped === false)) {
        this.swiped = true;
      } else if (parseInt(event.target.style.left, 10) >= -80 && 
                  parseInt(event.target.style.left, 10) <= 80 && 
                    (this.swiped === true)) {
        this.swiped = false;              
      }

    }
      
    }

  }
};
</script>

<style scoped>
  .header {
    position: sticky;
    z-index: 2;
    top: 0;
    text-align: center; 
    padding: 57px 10px 25px 10px;
    background-color: #f5f5f5;
  }
</style>